=head1 NAME

Gtk2::ImageView::Tool -  Interface for objects capable of being used as tools by Gtk2::ImageView

=cut

=for position DESCRIPTION

=head1 DESCRIPTION

Gtk2::ImageView::Tool is an interface that defines how Gtk2::ImageView interacts with objects that acts as tools. Gtk2::ImageView delegates many of its most important tasks (such as drawing) to its tool which carries out all the hard work. The Gtk2::ImageView package comes with two tools; Gtk2::ImageView::Tool::Dragger and Gtk2::ImageView::Tool::Selector, but by implementing your own tool it is possible to extend Gtk2::ImageView to do stuff its author didn't imagine.

Gtk2::ImageView uses Gtk2::ImageView::Tool::Dragger by default, as that tool is he most generally useful one. However, it is trivial to make it use another tool.

 my $view = Gtk2::ImageView->new;
 my $tool = Gtk2::ImageView::Tool::Selector ($view);
 $view->set_tool ($tool);

Using the above code makes the view use the selector tool instead of the default dragger tool.

=cut



=head1 HIERARCHY

  Glib::Interface
  +----Gtk2::ImageView::Tool



=cut

=for object Gtk2::ImageView::Tool Interface for objects capable of being used as tools by Gtk2::ImageView
=cut




=head1 METHODS

=head2 boolean = $tool-E<gt>B<button_press> ($ev)

=over

=item * $ev (Gtk2::Gdk::Event) 

=back

=head2 boolean = $tool-E<gt>B<button_release> ($ev)

=over

=item * $ev (Gtk2::Gdk::Event) 

=back

=head2 cursor = $tool-E<gt>B<cursor_at_point> ($x, $y)

=over

=item * $x (integer) 

=item * $y (integer) 

=back

Returns the cursor to display at the given coordinates.

=head2 boolean = $tool-E<gt>B<motion_notify> ($ev)

=over

=item * $ev (Gtk2::Gdk::Event) 

=back

=head2 $tool-E<gt>B<paint_image> ($opts, $drawable)

=over

=item * $opts (Gtk2::Gdk::Pixbuf::Draw::Opts) 

=item * $drawable (Gtk2::Gdk::Drawable) 

=back

Called whenever the image view decides that any part of the image it shows needs
to be redrawn.

=head2 $tool-E<gt>B<pixbuf_changed> ($reset_fit, $rect)

=over

=item * $reset_fit (boolean) 

=item * $rect (Gtk2::Gdk::Rectangle) 

=back

Indicate to the tool that either a part of, or the whole pixbuf that the image
view shows has changed. This method is called by the view whenever its pixbuf or
its tool changes. That is, when any of the following methods are used:

=over

=item Gtk2::ImageView::set_pixbuf()

=item Gtk2::ImageView::set_tool()

=item Gtk2::ImageView::damage_pixels()

=back

If the reset_fit parameter is TRUE, it means that a new pixbuf has been loaded
into the view.

=over

=item tool : the tool

=item reset_fit : whether the view is resetting its fit mode or not

=item rect : rectangle containing the changed area or NULL

=back




=cut


=head1 SEE ALSO

L<Gtk2::ImageView>, L<Glib::Interface>


=cut


=head1 COPYRIGHT

Copyright (C) 2007 by Jeffrey Ratcliffe.

This software is licensed under the GPL-3; see L<Gtk2::ImageView> for a full notice.


=cut

